# generated by datamodel-codegen:
#   filename:  workflow/base.json
#   version:   0.25.5

from __future__ import annotations

from enum import Enum
from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, Field


class Name(Enum):
    default = "default"
    atomsTooClose = "atomsTooClose"
    atomsOverlap = "atomsOverlap"


class Severity(Enum):
    info = "info"
    warning = "warning"
    error = "error"


class ConsistencyCheck(BaseModel):
    key: str
    """
    Key of the property of the entity on which the consistency check is performed in Mongo dot notation, e.g. 'basis.coordinates.1'
    """
    name: Name
    """
    Name of the consistency check that is performed, which is listed in an enum.
    """
    severity: Severity
    """
    Severity level of the problem, which is used in UI to differentiate.
    """
    message: str
    """
    Message generated by the consistency check describing the problem.
    """


class BaseWorkflowSchema(BaseModel):
    properties: Optional[List[Union[str, Dict[str, Any]]]] = None
    """
    Array of characteristic properties calculated by this workflow (TODO: add enums)
    """
    isUsingDataset: Optional[bool] = None
    """
    Whether to use the dataset tab in the job designer. Mutually exclusive with using the materials tab.
    """
    workflows: Optional[List[Dict[str, Any]]] = None
    """
    Array of workflows with the same schema as the current one.
    """
    field_id: Optional[str] = Field(None, alias="_id")
    """
    entity identity
    """
    slug: Optional[str] = None
    """
    entity slug
    """
    systemName: Optional[str] = None
    consistencyChecks: Optional[List[ConsistencyCheck]] = None
    schemaVersion: Optional[str] = "2022.8.16"
    """
    entity's schema version. Used to distinct between different schemas.
    """
    name: Optional[str] = None
    """
    entity name
    """
    isDefault: Optional[bool] = False
    """
    Identifies that entity is defaultable
    """
    metadata: Optional[Dict[str, Any]] = None
